/*

	Quick and Dirty Game Development Framework (QDGDF)

	Copyright (C) 2001 Angel Ortega <angel@triptico.com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	http://www.triptico.com

*/

#include <stdio.h>
#include <string.h>

#include "qdgdf_audio.h"

/* sound switch */
int _qdgdfa_sound=1;

/* 16 bit sound on/off */
int _qdgdfa_16_bit=1;

/* window title */
char _qdgdfa_window_title[150]="";


/*******************
	Code
********************/

FILE * qdgdfa_load_wav(char * filename, int * size, int * bits)
{
	FILE * f;
	char dummydata[256];
	int rlen,flen;
	short int b_per_sec,num_channels,tag;
	char riffid[5],waveid[5],fmtid[5],dataid[5];
	int _wav_frequency;

	if((f=fopen(filename,"rb"))==NULL)
		return(NULL);
  
	fread(riffid,1,4,f);
	riffid[4] = 0;
	fread(&rlen,1,4,f);
	fread(waveid,1,4,f);
	waveid[4] = 0;

	if(strcmp(waveid,"WAVE"))
	{
		fclose(f);
		return(NULL);
	}

	fread(fmtid,1,4,f);
	fmtid[4] = 0;
	flen=fgetc(f);
	flen+=(fgetc(f)*256);
	flen+=(fgetc(f)*65536);
	flen+=(fgetc(f)*16777216);

	if(flen>240)
		flen=240;

	fread(&tag,1,2,f);

	num_channels=fgetc(f);
	num_channels+=(fgetc(f)*256);
	_wav_frequency=fgetc(f);
	_wav_frequency+=(fgetc(f)*256);
	_wav_frequency+=(fgetc(f)*65536);
	_wav_frequency+=(fgetc(f)*16777216);
	b_per_sec=fgetc(f);
	b_per_sec+=(fgetc(f)*256);
	b_per_sec+=(fgetc(f)*65536);
	b_per_sec+=(fgetc(f)*16777216);

	*bits=fgetc(f);
	(*bits)+=(fgetc(f)*256);
	(*bits)*=8;

	fread(dummydata,1,(size_t)flen-14,f);
	fread(dataid,1,4,f);
	dataid[4] = 0;

	*size=fgetc(f);
	(*size)+=(fgetc(f)*256);
	(*size)+=(fgetc(f)*65536);
	(*size)+=(fgetc(f)*16777216);

	return(f);
}


