/*

	Quick and Dirty Game Development Framework (QDGDF)

	Copyright (C) 2001 Angel Ortega <angel@triptico.com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	http://www.triptico.com

*/

#ifndef QDGDF_VIDEO_H_
#define QDGDF_VIDEO_H_

#include <stdio.h>

extern int _qdgdfv_use_logger;
extern char _qdgdfv_logger_file[150];

extern int _qdgdfv_double_mode;
extern unsigned char * _qdgdfv_virtual_screen;
extern unsigned char _qdgdfv_clear_color;
extern unsigned int _qdgdfv_screen_x_size;
extern unsigned int _qdgdfv_screen_y_size;
extern int _qdgdfv_window_x;
extern int _qdgdfv_window_y;
extern char _qdgdfv_window_title[150];
extern char _qdgdfv_additional_info[150];
extern int _qdgdfv_additional_int_info;

extern int _qdgdfv_key_up;
extern int _qdgdfv_key_down;
extern int _qdgdfv_key_left;
extern int _qdgdfv_key_right;
extern int _qdgdfv_key_escape;
extern int _qdgdfv_key_space;
extern int _qdgdfv_key_enter;
/* Dan Compton made these changes and additions */
extern int _qdgdfv_key_control;
extern int _qdgdfv_key_shift_l;
extern int _qdgdfv_key_shift_r;
extern int _qdgdfv_key_alnum; /* catches alpha chars and numbers */
extern char _qdgdfv_alnum; /* contains the ascii char of alpha or number or might contain a OS dependent defined keycode which would be conditionally compiled in for x11 or win32 */

extern unsigned int _qdgdfv_palette[256*3];


char * qdgdfv_sprintf(char * fmt, ...);
void qdgdfv_logger(char * where, char * msg);
void volatile qdgdfv_bang(char * where, char * msg);
void * qdgdfv_malloc(int size);
FILE * qdgdfv_fopen(char * file, char * mode);

void qdgdfv_load_pcx(unsigned char * pcx, char * pcxfile, int size);

void qdgdfv_input_poll(void);
void qdgdfv_clear_virtual_screen(void);
void qdgdfv_dump_virtual_screen(void);

void qdgdfv_startup(void);
void qdgdfv_shutdown(void);

#endif /* QDGDF_VIDEO_H_ */

