#include "intqueue.h"

int IQRealloc(IntQueue *iq, size_t howmuch) {
	int *temp;
	int result = 1;
	if(iq->num + howmuch > iq->size) {
		temp = realloc(iq->queue, sizeof(int) * (iq->size + howmuch));
		if(temp != NULL) {
			iq->queue = temp;
			iq->size += howmuch;
		}
		else result = 0;
	}

	return result;
}

IntQueue *IQInit(size_t size) {
	IntQueue *iq = malloc(sizeof(*iq));
	if(iq != NULL) {
		iq->num = 0;
		iq->size = 0;
		iq->queue = NULL;
		if(IQRealloc(iq, size) == 0) {
			free(iq);
			iq = NULL;
		}
	}
	return iq;
}

int IQPush(IntQueue *iq, int data) {
	int result = 1;
	if(IQRealloc(iq, IQ_REALLOC_SIZE)) {
		iq->queue[iq->num] = data;
		iq->num++;
	}
	else result = 0;

	return result;
}
		
void IQClear(IntQueue *iq) { iq->num = 0; }

int IQPop(IntQueue *iq, int *data) {
	int result = 1;
	if(iq->num > 1) {
		iq->num--;
		*data = iq->queue[0];
		memmove(iq->queue, &iq->queue[1], sizeof(int) * iq->num);	
	}
	else if(iq->num == 1) {
		iq->num--;
		*data = iq->queue[0];
	}
	else result = 0;

	return result;
}

int IQCopy(IntQueue *dest, IntQueue *src) {
	int result = 1;
	if(IQRealloc(dest, src->num)) {
		memcpy(dest->queue, src->queue, sizeof(int) * src->num);
		dest->num = src->num;
	}
	else result = 0;

	return result;
}

int compareint(const void *o1, const void *o2) {
	return (*(int *)o1 < *(int *)o2)? -1 : ((*(int *)o1 > *(int *)o2)? 1 : 0);
}

void IQSort(IntQueue *iq) {
	qsort(iq->queue, iq->num, sizeof(int), compareint);
}

void IQDestroy(IntQueue *iq) {
	if(iq != NULL) {
		free(iq->queue);
		free(iq);
	}
}

